/*
 * Water ripples
 *
 * This is really convoluted. Hack at own risk
 */

/* Generic */
#define RAND(x) ((float) rand() / RAND_MAX * x)
#define ALPHA 1
#define FADE 2
#define THREED 3

/* VGA Stuff */
#define DEFMODE G320x200x256
#define DEFMODESTRING "320x200x256"

void SetupVga(void);
void DisableVga(void);
void DumpVga(void);
void DumpPalette(void);
void SetGrayscalePalette(void);
void GrayScaleGradient(void);

/* Pregen stuff */
#define WIDTH 320
#define HEIGHT 200
#define MAXRADIUS 128
#define PI 3.14159265358979323846
static char *SineTable[MAXRADIUS];
void GenInitialSineTable(void);
void GenCopySineTable(int sineno);
void ShowSine(int sineno);

void GenWaveTable(void);
void ShowWaveTable(int radius);
int ShowBasicRipple(int radius);

/* Actual Ripple Shite */
typedef struct rippnode {
    short posx;
    short posy;
    unsigned char radius;
    char *sinepos;
    unsigned int frameno;
    struct rippnode *previous;
    struct rippnode *next;
} Ripple;

void GenRippList(void);
void AddRippNode(Ripple *node);
void KillRippNode(Ripple *node);
void GenRipple(short x, short y, unsigned char radius);
void DrawRipple(Ripple *node);
void RippleIteration(void);
void DrawAlpha(void);
void GenerateBackground(void);
void DumpBackground(void);
void AlphaFrame(void);
void FadeFrame(void);
void ThreeDFrame(void);
